/**************************************************
 *                                                *
 *  JBoss Labs: Creating Professional Open Source *
 *                                                *
 *   Distributable under LGPL license.            *
 *   See terms of license at gnu.org.             *
 *                                                *
 *************************************************/
package org.jboss.wiki;

import java.util.Date;
import java.util.HashMap;
import java.util.Set;
import java.util.TreeSet;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

/**
 * 
 * @author <a href="mailto:dsicore@jboss.org">Damon Sicore</a>
 * @author <a href="mailto:tomasz.szymanski@jboss.com">Tomasz Szymanski</a>
 * @version $Id$
 * 
 * getLink - gets a link to a given page getEditLink - same but link to edit
 * that page save - saves page with given attributes getContent - retrieves the
 * content from a wiki page and returns it in the type specified by 'type'
 * Probably need to have some sort of WikiSession per request with an associated
 * WikiContext, but maybe not--don't want to duplicate PortletSession
 */
public class WikiEngine {

	/**
	 * <p>
	 * </p>
	 * 
	 */
	private HashMap<String, WikiPage> pages;

	private HashMap<String, WikiType> wikiTypes;

	private MediaDataSource mediaDataSource;

	WikiPage noSuchPage;

	/**
	 * <p>
	 * Does ...
	 * </p>
	 * 
	 * 
	 * @param pageName
	 * @return
	 * @param wikiContext
	 */
	public String get(String pageName, WikiContext wikiContext) {
		// your code here
		return null;
	}

	/**
	 * <p>
	 * Does ...
	 * </p>
	 * 
	 * 
	 * @param pageName
	 * @param content
	 * @param wikiContext
	 * @return
	 */
	public boolean save(String pageName, String content, WikiContext wikiContext) {
		// your code here
		return false;
	}

	public boolean pageExists(String pageName) {

		return mediaDataSource.pageExists(pageName);
	}

	/**
	 * <p>
	 * Does ...
	 * </p>
	 * 
	 * 
	 * @param pageName
	 * @param type
	 * @return
	 */
	public String getContent(String pageName, String type) {
		// your code here
		return null;
	}

	/**
	 * <p>
	 * Does ...
	 * </p>
	 * 
	 * 
	 * @param pageName
	 * @return
	 * @param wikiContext
	 */
	public WikiPage getByName(String pageName, WikiContext wikiContext) {

		WikiPage ret = null;

		if (pages.containsKey(pageName)) {
			ret = pages.get(pageName);
		} else {
			ret = mediaDataSource.getPage(pageName);

			pages.put(pageName, ret);
		}

		if (ret != null) {
			if (wikiContext != null) {
				return wikiContext.process(ret);
			} else {
				return ret;
			}
		} else {
			try {
				ret = (WikiPage) noSuchPage.clone();
				ret.setName(pageName);
			} catch (CloneNotSupportedException cne) {
				System.err.println(cne);

			}
			if (wikiContext != null) {
				return wikiContext.process(ret);
			} else {
				return ret;
			}
		}
	}

	public WikiPage getByName(String pageName, WikiContext wikiContext,
			int version) {

		WikiPage ret = null;

		if (pages.containsKey(pageName)) {
			ret = pages.get(pageName);
		} else {
			ret = mediaDataSource.getPage(pageName);

			pages.put(pageName, ret);
		}

		ret = ret.getPageAtVersion(true, version);

		if (ret != null) {
			if (wikiContext != null) {
				return wikiContext.process(ret);
			} else {
				return ret;
			}
		} else {
			// return noSuchPage if there isn't any
			/*try {
				ret = (WikiPage) noSuchPage.clone();
			} catch (CloneNotSupportedException cne) {
				System.err.println(cne);

			}
			if (wikiContext != null) {
				return wikiContext.process(ret);
			} else {
				return ret;
			}*/
			return null;
		}
	}

	/**
	 * <p>
	 * Does ...
	 * </p>
	 * 
	 * 
	 * @return
	 */
	public void init() {
		mediaDataSource = new FileDataSource();
		pages = new HashMap<String, WikiPage>();
		wikiTypes = new HashMap<String, WikiType>();

		noSuchPage = new WikiPage("", new Credentials(""),
				"There is no such page. Click on EDIT to start it.", 0, 0,
				null, mediaDataSource);

		loadWikiTypes();
	}

	/**
	 * <p>
	 * Parses configuration file to get WikiTypes
	 * </p>
	 * 
	 * 
	 * @return
	 */
	protected void loadWikiTypes() {
		try {
			wikiTypes.clear();

			SAXParser sp = (SAXParserFactory.newInstance()).newSAXParser();
			sp.parse(
					WikiTypeHandler.class.getResourceAsStream("WikiTypes.xml"),
					new WikiTypeHandler(this));
		} catch (Exception se) {
			System.err.println("Error while parsing WikiType configuration: "
					+ se);
		}
	}

	/**
	 * <p>
	 * Does ...
	 * </p>
	 * 
	 * 
	 * @return
	 * @param pageName
	 * @param wikiContext
	 */
	public void lock(String pageName, WikiContext wikiContext) {
		// your code here
		// return null;
	}

	/**
	 * <p>
	 * Does ...
	 * </p>
	 * 
	 * 
	 * @return
	 * @param pageName
	 * @param wikiContext
	 */
	public void unlock(String pageName, WikiContext wikiContext) {
		// your code here
		// return null;
	}

	/**
	 * <p>
	 * Does ...
	 * </p>
	 * 
	 * 
	 * @return
	 * @param path
	 * @param wikiContext
	 */
	public void getByPath(String path, WikiContext wikiContext) {
		// your code here
		// return null;
	}

	/**
	 * <p>
	 * Does ...
	 * </p>
	 * 
	 * 
	 * @return
	 * @param pageName
	 * @param wikiContext
	 */
	public void setProperty(String pageName, WikiContext wikiContext) {
		// your code here
		// return null;
	}

	/**
	 * <p>
	 * Does ...
	 * </p>
	 * 
	 * 
	 * @return
	 * @param wikiType
	 * @param userCredentials
	 */
	public void getWikiContext(String wikiType, Credentials userCredentials) {
		// your code here
		// return null;
	}

	public void addWikiType(String name, WikiType wikiType) {
		System.out.println("[WIKIENGINE]: Added WikiType: " + name + " Class: "
				+ wikiType);
		wikiTypes.put(name, wikiType);
	}

	public WikiType getWikiType(String wikiTypeName) {
		//System.out
		//		.println("[WIKITYPE REQUEST]: " + wikiTypes.get(wikiTypeName));
		return wikiTypes.get(wikiTypeName);
	}

	/**
	 * <p>
	 * </p>
	 * 
	 */
	public WikiEngine() {
		init();
	}

	public MediaDataSource getMediaDataSource() {
		return mediaDataSource;
	}

	public static void main(String[] args) {
		WikiEngine we = new WikiEngine();

		WikiType wt = we.getWikiType("HTML");

		WikiContext wc = new WikiContext(null, wt, null);

		WikiPage wp = new WikiPage("name", new Credentials("tomek"),
				"[content|ble sme]", 1, 1, new Date(), we.getMediaDataSource());

		wp = wc.process(wp);

		System.out.println(wp.getContent());
	}

	public void refreshPage(String pageName) {
		if (pages.containsKey(pageName)) {
			pages.remove(pageName);
		}
	}

	public Set<String> findPages(String searchQuery) {
		//System.out.println("Starting search: " + searchQuery);
		WikiSearch wikiSearch = new WikiSearch(searchQuery);

		Set<String> resPages = new TreeSet<String>();

		Set<String> pages = getMediaDataSource().getAllPageNames();

		for (String name : pages) {
			WikiPage temp = getByName(name, null);
			if (temp != null) {
				if (wikiSearch.matches(temp.getPageContent().toLowerCase())) {
					resPages.add(name);
				}
			}
		}

		//System.out.println("Search completed");
		return resPages;
	}

}
