/**************************************************
 *                                                *
 *  JBoss Labs: Creating Professional Open Source *
 *                                                *
 *   Distributable under LGPL license.            *
 *   See terms of license at gnu.org.             *
 *                                                *
 *************************************************/
package org.jboss.wiki;

import java.io.File;
import java.io.Serializable;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Set;

import org.jboss.portal.core.model.User;

/**
 * <p>
 * </p>
 * 
 */
/**
 * 
 * @author <a href="mailto:dsicore@jboss.org">Damon Sicore</a>
 * @author <a href="mailto:tomasz.szymanski@jboss.com">Tomasz Szymanski</a>
 * @version $Id$
 */
public class WikiPage implements Serializable, WikiProperties, Cloneable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/* number of minutes after which page lock will expire */
	private static final int LOCK_TIME = 30;

	private Date lockTime = null;

	private String lockUser;
	
	private long length = 0;

	/**
	 * <p>
	 * Represents ...
	 * </p>
	 * 
	 */
	private String name;

	/**
	 * <p>
	 * Represents ...
	 * </p>
	 * 
	 * WikiPage This class is _abstract_ and has to be extended by the class
	 * that we're willing to show our content
	 * 
	 * functions to be extended: WikiPage(...) - constructor getAttributes() -
	 * gets set of atributes to be send to the appropriate JSP page
	 * saveThisPage(data:Object) - saves next version of this page with new data
	 * getJSPPath() - gets apropriate JSP page to show plugin
	 * getDataProviderName - gets name of the plugin _must_ be the same as in
	 * the plugin name in plugin.xml
	 */
	private Credentials lastAuthor;

	/**
	 * <p>
	 * Represents ...
	 * </p>
	 * 
	 */
	private int lastVersion;
	
	private int version;

	/**
	 * <p>
	 * Represents ...
	 * </p>
	 * 
	 */
	private Date editDate;

	/**
	 * <p>
	 * Represents ...
	 * </p>
	 * 
	 */
	private MediaDataSource mediaDataSource;

	/**
	 * <p>
	 * </p>
	 * 
	 */
	public WikiEngine wikiEngine;

	/**
	 * <p>
	 * </p>
	 * 
	 */
	public WikiEngine wikiEngine_1;

	private String pageContent;


	public WikiPage(String pageName, Credentials pageAuthor,
			String pageContent, int pageLastVersion, int thisVersion, Date editDate, MediaDataSource mediaDataSource) {
		name = pageName;
		lastAuthor = pageAuthor;
		this.pageContent = pageContent;
		lastVersion = pageLastVersion;
		version = thisVersion;
		this.editDate = editDate;
		this.mediaDataSource = mediaDataSource;
	}

	/**
	 * <p>
	 * Does ...
	 * </p>
	 * 
	 * 
	 * @return
	 */
	public HashMap getAttributes() {
		// your code here
		return null;
	}

	/**
	 * <p>
	 * Does ...
	 * </p>
	 * 
	 */
	public void save() {
		mediaDataSource.savePage(this, null);
	}

	/**
	 * <p>
	 * Does ...
	 * </p>
	 * 
	 * 
	 * @return
	 */
	public String getPath() {
		// your code here
		return null;
	}

	/**
	 * <p>
	 * Does ...
	 * </p>
	 * 
	 * 
	 * @return
	 * @param mds
	 */
	public void setMediaDataSource(MediaDataSource mds) {
		mediaDataSource = mds;
	}

	/**
	 * <p>
	 * Does ...
	 * </p>
	 * 
	 * 
	 * @param version
	 * @return
	 */
	public boolean updateToVersion(int version) {
		// your code here
		return false;
	}

	/**
	 * <p>
	 * Does ...
	 * </p>
	 * 
	 * 
	 * @return
	 * @param version
	 */
	public WikiPage getPageAtVersion(boolean loadContent, int version) {
		if (version == lastVersion) {
			return this;
		}
		else {
			return mediaDataSource.getPageAtVersion(this, loadContent, version);
		}
	}

	/**
	 * <p>
	 * Does ...
	 * </p>
	 * 
	 * 
	 * @return
	 */
	public String getContent() {
		return getPageContent();
	}

	/**
	 * <p>
	 * Does ...
	 * </p>
	 * 
	 * 
	 * @return
	 */
	public MediaDataSource getMediaDataSource() {
		// your code here
		return null;
	}

	/**
	 * <p>
	 * Does ...
	 * </p>
	 * 
	 * 
	 * @return
	 * @param text
	 */
	public void setWikiText(int text) {
		// your code here
		// return null;
	}

	public void showPage() {
		System.out.println("Page name: " + getName());
		System.out.println("Page author: " + getLastAuthor());
		System.out.println("Page version: " + getLastVersion());
		System.out.println("Page editdate: " + getEditDate());
		System.out.println("Page Content: \n" + getContent());
	}

	/**
	 * <p>
	 * </p>
	 * 
	 */
	public MediaInternalization mediaInternalization;

	public java.util.Date getEditDate() {
		return editDate;
	}

	public void setEditDate(java.util.Date editDate) {
		this.editDate = editDate;
	}

	public Credentials getLastAuthor() {
		return lastAuthor;
	}

	public void setLastAuthor(Credentials lastAuthor) {
		this.lastAuthor = lastAuthor;
	}

	public int getLastVersion() {
		return lastVersion;
	}

	public void setLastVersion(int lastVersion) {
		this.lastVersion = lastVersion;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getPageContent() {
		if (pageContent == null) {
			// page wasn't loaded with conent - lets do it
			mediaDataSource.getContentAtVersion(this, true, version);
		}
		return pageContent;
	}

	public void setPageContent(String pageContent) {
		this.pageContent = pageContent;
	}

	@Override
	public Object clone() throws CloneNotSupportedException {
		WikiPage clonedPage = new WikiPage(getName(), getLastAuthor(),
				getPageContent(), getLastVersion(), getVersion(), getEditDate(), mediaDataSource);
		
		clonedPage.setLength(getLength());
		
		return clonedPage;
	}

	public void unlock(User user) {
		System.out.println("UNLOCK: "+user.getUserName()+" save user: "+lockUser);
		if ((user.getUserName()).equals(lockUser)) {
			System.out.println("Unlocking page");
			lockTime = null;
			lockUser = null;
		}
	}

	public Date lock(User user) {
		Date now = new Date();
		Date expDate = null;
		Date retDate = lockTime;

		if (this.lockTime != null) {
			// lets calculete expire date of current lock

			Calendar calExpireDate = Calendar.getInstance();
			calExpireDate.setTime(this.lockTime);
			calExpireDate.add(Calendar.MINUTE, LOCK_TIME);
			expDate = calExpireDate.getTime();

			if (expDate.before(now)) {
				// lock expired. take it out
				lockTime = null;
				lockUser = null;
			}
		}

		if (this.lockTime == null) {
			System.out.println("LOCK: "+user.getUserName());
			
			// page isn't locked or lock expired. Lets lock it.
			this.lockTime = now;
			this.lockUser = user.getUserName();
			System.out.println("LOCK: "+lockUser);
			retDate = null;
		}

		return retDate;
	}

	public String getLockUser() {
		return lockUser;
	}

	public int getVersion() {
		return version;
	}

	public void setVersion(int version) {
		this.version = version;
	}

	public long getLength() {
		if ((length == 0)&&(getPageContent().length() != 0)) {
			length = getPageContent().length();
		}
		
		return length;
	}

	public void setLength(long length) {
		this.length = length;
	}
	
	public void addAttachement(File attFile, String attName, String user) {
		mediaDataSource.addAtachement(attFile, attName, this, user);
	}
	
	public Set<String> getAttachementsSet() {
		return mediaDataSource.getAttachementsSet(this);
	}
}
