/**************************************************
 *                                                *
 *  JBoss Labs: Creating Professional Open Source *
 *                                                *
 *   Distributable under LGPL license.            *
 *   See terms of license at gnu.org.             *
 *                                                *
 *************************************************/
package org.jboss.wiki;

import java.io.InputStream;
import java.util.Properties;

/**
 * <p></p>
 * 
 */
/**
 *
 * @author <a href="mailto:dsicore@jboss.org">Damon Sicore</a>
 * @author <a href="mailto:tomasz.szymanski@jboss.com">Tomasz Szymanski</a>
 * @version $Id$
 */
public abstract class WikiPlugin {
	 
	protected WikiEngine wikiEngine;
	
	private Properties pluginProps;
	
	private String name;
	
	final static String  propFileName = "wikiPlugins.properties";
/**
 * <p></p>
 * 
 */

/**
 * <p>Does ...</p>
 * 
 * 
 * @return 
 * @param content 
 */
    public abstract WikiPage process(final WikiPage wikiPage, WikiSession wikiSession);

/**
 * <p>Does ...</p>
 * 
 * 
 * @return 
 */
    
    public abstract void init();
    
    public void setWikiEngine(WikiEngine wikiEngine) {
    	this.wikiEngine = wikiEngine;
    	
    	// we can treat it as "init" function - it's executed after creating instance of plugin
    	// load props
    	
    	pluginProps = new Properties();
    	
    	try {
    		
    		InputStream propsStream = FileDataSource.class.getResourceAsStream(propFileName);
    		
    		pluginProps.load(propsStream);
    	}
    	catch (Exception e) {
    		System.err.println("[WikiPlugin]: Cannot load WikiPlugin property file: "+e);
    	}
    }
    
    protected String getProperty(String propertyName) {
    	return pluginProps.getProperty(propertyName);
    }

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}
    

 }
