package org.jboss.wiki;

import java.util.StringTokenizer;
import java.util.Vector;

public class WikiSearch {
	Vector<String> requestTokens;
	Vector<String> forbiddenTokens;
	Vector<String> requiredTokens;
	
	public WikiSearch(String searchQuery) {
		requestTokens = new Vector<String>();
		forbiddenTokens = new Vector<String>();
		requiredTokens = new Vector<String>();
		
        StringTokenizer st = new StringTokenizer( searchQuery, " \t," );


        //
        //  Parse incoming search string
        //

        while( st.hasMoreTokens() )
        {
            String token = st.nextToken().toLowerCase();


            switch( token.charAt(0) )
            {
              case '+':
                token = token.substring(1);
                requiredTokens.add(token);
                break;
                
              case '-':
            	token = token.substring(1);
                forbiddenTokens.add(token);
                break;

              default:
                requestTokens.add(token);
                break;
            }
        }
	}
	
	public boolean matches(String content) {
		for (int i = 0; i < forbiddenTokens.size(); i++) {
			if (content.indexOf(forbiddenTokens.get(i)) != -1) {
				// there is forbidden token
				return false;
			}
		}
		
		for (int i = 0; i < requiredTokens.size(); i++) {
			if (content.indexOf(requiredTokens.get(i)) == -1) {
				// lack of one of the required tokens
				return false;
			}
		}
		
		if (requiredTokens.size() > 0) {
			// there is at least one requirted token and it has been found
			return true;
		}
		
		for (int i = 0; i < requestTokens.size(); i++) {
			if (content.indexOf(requestTokens.get(i)) != -1) {
				// found at least one required token
				return true;
			}
		}
		
		// didn't found anything that fits
		return false;
	}
}
