/**************************************************
 *                                                *
 *  JBoss Labs: Creating Professional Open Source *
 *                                                *
 *   Distributable under LGPL license.            *
 *   See terms of license at gnu.org.             *
 *                                                *
 *************************************************/

package org.jboss.wiki.plugins;

import java.util.Set;

import org.jboss.wiki.WikiPage;
import org.jboss.wiki.WikiPlugin;
import org.jboss.wiki.WikiSession;

public class AttachmentListPlugin extends WikiPlugin {

	private String host = "";
	
	@Override
	public WikiPage process(WikiPage wikiPage, WikiSession wikiSession) {
		host = (String)wikiSession.getAttribute("hostURL")+"/wiki/";
		
		WikiPage newPage = null;
		
		try {
			newPage = (WikiPage) wikiPage.clone();
		} catch (CloneNotSupportedException cl) {
			System.err.println(cl);
		}

		Set<String> attachements = newPage.getAttachementsSet();

		if (attachements != null) {
			String newContent = newPage.getPageContent();

			newContent += "\n<hr />\n<h3>Attachments:</h3>\n";

			for (String s : attachements) {
				String href = host+newPage.getName() + "/" + s;
				newContent += "<a href=\""+href+"\">"+href + "</a><br>\n";
			}

			newPage.setPageContent(newContent);
		}

		return newPage;
	}


	@Override
	public void init() {
		
	}

}
