package org.jboss.wiki.plugins;

import java.io.IOException;

import org.jboss.wiki.WikiPage;
import org.jboss.wiki.WikiPlugin;
import org.jboss.wiki.WikiSession;

public class DiffPlugin extends WikiPlugin {

	private DifferenceEngine differenceEngine;

	@Override
	public WikiPage process(WikiPage wikiPage, WikiSession wikiSession) {
		WikiPage newPage = null, 
				 prevNewPage = null;
		
		try {
			newPage = (WikiPage) wikiPage.clone();
		} catch (CloneNotSupportedException e) {
			System.err.println(e);
		}
		
		prevNewPage = newPage.getPageAtVersion(true, newPage.getVersion()-1);
		
		String diff = differenceEngine.makeDiff(prevNewPage.getContent(), newPage.getContent());
		
		try {
		newPage.setPageContent(differenceEngine.colorizeDiff(diff));
		}
		catch (IOException e) {
			System.err.println(e);
		}
		
		return newPage;
	}

	@Override
	public void init() {
		differenceEngine = new DifferenceEngine("ISO-8859-1");

	}

}
