package org.jboss.wiki.plugins;

import java.util.Set;

import org.jboss.wiki.WikiPage;
import org.jboss.wiki.WikiPlugin;
import org.jboss.wiki.WikiSession;

public class FindResultPlugin extends WikiPlugin {

	@Override
	public WikiPage process(WikiPage wikiPage, WikiSession wikiSession) {
		WikiPage newPage = null;

		try {
			newPage = (WikiPage) wikiPage.clone();
		} catch (CloneNotSupportedException cl) {
			System.err.println(cl);
		}

		Set<String> pages = (Set<String>) wikiSession
				.getAttribute("findResult");

		StringBuilder pageStr = new StringBuilder("!!!__Find results:__\n");

		if (pages.size() == 0) {
			pageStr.append("''NONE FOUND''");
		} else {
			for (String p : pages) {
				pageStr.append("[").append(p).append("]").append("\\\\\n");
			}
		}

		newPage.setPageContent(pageStr.toString());

		return newPage;
	}

	@Override
	public void init() {
		// TODO Auto-generated method stub

	}

}
