package org.jboss.wiki.plugins;

import java.util.Vector;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.jboss.wiki.WikiPage;
import org.jboss.wiki.WikiPlugin;
import org.jboss.wiki.WikiSession;

public class FriendlyLinkPlugin extends WikiPlugin {

	private String url;
	private String pattern;
	
	private String translateLinks(String content) {
		//<a href="http://localhost:8080/portal/index.html?ctrl:id=window.default.WikiPortletWindow&ctrl:type=action&page=JBossWiki">
		String newContent = content;
		Vector<String> replaces = new Vector<String>();
		
		Matcher matcher = Pattern.compile(pattern).matcher(newContent);
		
		while (matcher.find()) {
			String link = content.substring(matcher.start(), matcher.end());
			replaces.add("<a href=\""+url+link.substring(link.lastIndexOf("&page=")+("&page=".length()), link.length()-2)+"\" >");
		}
		
		for (int i = 0; i < replaces.size(); i++) {
			matcher = Pattern.compile(pattern).matcher(newContent);
			newContent = matcher.replaceFirst(replaces.get(i));
		}
		
		//System.out.println(content);
		
		return newContent;
	}
	
	@Override
	public WikiPage process(WikiPage wikiPage, WikiSession wikiSession) {
		url = (String)wikiSession.getAttribute("hostURL")+"/wiki/";
		
		pattern = "<a href=\""+(((String)wikiSession.getAttribute("hostURL")+(String)wikiSession.getAttribute("actionURL")).replaceAll("\\.","\\\\.").replaceAll("\\?", "\\\\?"))+"&page=\\w+\">";
		
		//System.out.println(pattern);
		
		WikiPage newPage = null;

		try {
			newPage = (WikiPage) wikiPage.clone();
		} catch (CloneNotSupportedException cl) {
			System.err.println(cl);
		}

		newPage.setPageContent(translateLinks(newPage.getPageContent()));

		return newPage;
	}

	@Override
	public void init() {
		
	}

}
