package org.jboss.wiki.plugins;

import org.jboss.wiki.WikiPage;
import org.jboss.wiki.WikiPlugin;
import org.jboss.wiki.WikiSession;

public class TrailPlugin extends WikiPlugin {

	@Override
	public WikiPage process(WikiPage wikiPage, WikiSession wikiSession) {
		WikiPage newPage = null;
		try {
			newPage = (WikiPage) wikiPage.clone();
		} catch (CloneNotSupportedException e) {
			System.err.println(e);
		}

		String trail = "["+newPage.getName()+"] ";
		
		if (wikiSession.getAttribute("TRAIL") != null) {
			String oldTrail = (String)wikiSession.getAttribute("TRAIL");
			
			if (oldTrail.endsWith(trail)) {
				// do not add trail if page reloads
				trail = oldTrail;
			}
			else {
				trail = oldTrail + trail;
			}
		}
		
		wikiSession.setAttribute("TRAIL", trail);
		
		newPage.setPageContent("Your trail: "+trail+"\n----\n"+newPage.getContent());
		
		return newPage;
	}

	@Override
	public void init() {
		// TODO Auto-generated method stub

	}

}
